function G=norm_green(a);

%Green's function of normalized laplacian
%of matrix a

L=sym_laplacian(a);
[phi v]=eig(L);
[vs ord]=sort(diag(v));
phi=phi(:,ord);

n=length(a);

G=zeros(n);

for i=1:n
   for j=1:n
      for k=2:n
         G(i,j)=G(i,j) + phi(i,k)*phi(j,k)/vs(k);
      end;
   end
end;

G=zeros(n);
for j=2:n
  G=G+phi(:,j)*phi(:,j)'/vs(j);
end;