%%%
%%% Naive illustrations of some facs concerning commute time
%%% taken from the paper
%%% Clustering and Embedding Using Commute Times
%%% by Huaijun (John) Qiu and Edwin R. Hancock: 
%%% IEEE Trans. PAMI, vol. 29, no. 11, pp. 1873-1890
%%%



a=load('gr5_2.adj');
n=length(a);

%symmetric laplacian
L=sym_laplacian(a);

%Green's function of the symmetric laplacian
G=norm_green(a);

%some properties of Symmetric Green's function:

% 1. G=pinv(L)
L1=pinv(L);
err1=sum(sum(abs(L1-G),2));
fprintf('err1: %e (G=pinv(L))\n',err1)

% 2. G*L=L*G
gl=G*L;
lg=L*G;
err2=norm(gl-lg,'fro');
fprintf('err2: %e (G*L = L*G)\n',err2)

% 3. 
[phi v]=eig(L);
[vs ord]=sort(diag(v));
phi=phi(:,ord);

g3=eye(n)-phi(:,1)*phi(:,1)';
err3=norm(gl-g3,'fro');
fprintf('err3: %e\n',err3)

Gu=unnorm_green(a);
Gg=graph_green(a);

T=diag(1./sum(a,2));
err4=norm(Gu-Gg*T,'fro'); 
fprintf('err4: %e\n',err4)

T=diag(1./sqrt(sum(a,2)));
err5=norm(Gu-T*G*T,'fro'); 
fprintf('err5: %e (eq. (5))\n',err5)

CT1=commute_time_1(a);
CT2=commute_time_2(a);
err6=sum(sum(abs(CT1-CT2),2));
fprintf('err6: %e\n',err6)

CT3=commute_time_3(a);
err7=sum(sum(abs(CT1-CT3),2));
fprintf('err7: %e\n',err7)

CT4=commute_time_4(a);
err8=sum(sum(abs(CT1-CT4),2));
fprintf('err8: %e\n',err8)

