function G=unnorm_green(a);

%Green's function of combinatorial laplacian
%of matrix a

L=com_laplacian(a);
[phi v]=eig(L);
[vs ord]=sort(diag(v));
phi=phi(:,ord);

n=length(a);

G=zeros(n);

for i=1:n
   for j=1:n
      for k=2:n
         G(i,j)=G(i,j) + phi(i,k)*phi(j,k)/vs(k);
      end;
   end
end;
