%% Implementation of the algorithm from the paper
%% Wu & Huberman: "Fiding communities in linear time: a physics approach"
%%
clear all; close all;

A = load('karate.adj');
n = length(A);

%battery hooked to nodes 1 and 34
ord = 1:n;
whereHoked=[12 30];
ord(whereHoked) = []; 
ord=[whereHoked ord];
I = eye(n-2);

%ordering rows and columns according tu ORD
A1 = A(ord,ord);

%node degrees
deg = sum(A1,2);
d = 1./deg(3:n);

B = diag(d)*A1(3:n,3:n);
C = diag(d)*A1(3:n,1);
V = inv(I-B)*C;

Vs=sort(V,'ascend');
figure(1), plot(Vs,'b.-'); title('Node potentials')
V = [1; V];
V = [V; 0];

[vs is] = sort(V);
%figure,plot(V,'k-*'); grid on; print vs

delta=[];
for i=2:n
   delta = [delta; vs(i)-vs(i-1)];
end;

[ds ids] =sort(-delta);
ds = -ds;

%%
%% second method
%%

%graph laplacian
L0 = diag(deg)-A1;

%its subset
L = L0(3:n,3:n);

%first subcolumn of the adjacency matrix
D = A1(3:n,1);

%solution
V1 = inv(L)*D;
V1 = [1; V1];
V1 = [V1; 0];

%%
%% third method (iterative)
%%

U = zeros(n,1);
U(1) = 1;

maxIter = 100;

for iter=1:maxIter
   for i=3:n
      ss=0;
      neigh = find(A1(i,:)>0);
      for j = 1:length(neigh)
         ss = ss + U(neigh(j));
      end;
      U(i) = ss/deg(i);
   end;
end;
U(2)=[];
U = [U; 0];

[V V1 U]

w = [1; V; 0];

[us, ius] = sort(w);

figure(2);plot(us,'k-*'); grid on; %axis([0 120 0.35 0.65]);
print vfootball

us1=[];
for i=2:length(us)
   us1 = [us1; us(i)-us(i-1)];
end;
figure(3); plot(us1,'k-*'); grid on;
      
