%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Original algorithm from Fig. 2
%% in Fowlkes et al. (2004)
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [V,err]=Fowlkes(A,B,UU,p);

m = length(A);

d1 = sum([A; B'],1);
d2 = sum(B,1) + sum(B',1)*pinv(A)*B;
dhat = sqrt(1./[d1 d2])';
A = A.*(dhat(1:m)*dhat(1:m)');
B = B.*(dhat(1:m)*dhat(m+1:end)');
Asi = sqrtm(pinv(A));
Q = A + Asi*B*B'*Asi;
[U,L,T]=svd(Q);
V = [A; B']*Asi*U*pinv(sqrt(L));
%% end of Fowles

%quality of the approximation
err=zeros(p,1);
for i=1:p
  V(:,i) = V(:,i)/norm(V(:,i));
  if norm(UU(:,i)+V(:,i))<norm(UU(:,i)-V(:,i))
    V(:,i)=-V(:,i);
  end;
  err(i)=norm(V(:,i)-UU(:,i));
end;

