%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%
%% Approximation using eqn. (4)
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [V,err]=OneShot(A,B,UU,p);
%input:
% K  - kernel to be approximated
% UU - true eigenvectors of K
% m  - number of rows/columns used to find the approximation (m < size(K,1))
% p  - number of eigenvectors to be returned (p <= m)

%if (m >= size(K,1)), error('m exceeds size(K,1)'); end;
%if (p > m), error('p exceeds m'); end;

Asi=sqrtm(pinv(A));
S=A+Asi*B*B'*Asi;

[U,L,T]=svd(S);
V=[A; B']*Asi*U*pinv(sqrt(L));

%quality of the approximation
err=zeros(p,1);
for i=1:p
  if norm(UU(:,i)+V(:,i))<norm(UU(:,i)-V(:,i))
    V(:,i)=-V(:,i);
  end;
  err(i)=norm(V(:,i)-UU(:,i));
end;
